diff --git a/rtemsbsd/include/machine/atomic.h b/rtemsbsd/include/machine/atomic.h
index a4b6b488..5d48a189 100644
--- a/rtemsbsd/include/machine/atomic.h
+++ b/rtemsbsd/include/machine/atomic.h
@@ -1021,523 +146,729 @@ static inline uint32_t
 atomic_load_acq_32(volatile uint32_t *p)
 {
 	uint32_t tmp;
+	_ATOMIC_LOAD(uint32_t, p, memory_order_acquire, true);
+	return (tmp);
+}
 
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_uint_least32_t *q =
-	    reinterpret_cast<std::atomic_uint_least32_t *>(const_cast<uint32_t *>(p));
+static inline long
+atomic_load_long(volatile long *p)
+{
+	long tmp;
+	_ATOMIC_LOAD(long, p, memory_order_relaxed, false);
+	return (tmp);
+}
 
-	tmp = q->load(std::memory_order_acquire);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_uint_least32_t *q = (atomic_uint_least32_t *)RTEMS_DEVOLATILE(uint32_t *, p);
+static inline long
+atomic_load_acq_long(volatile long *p)
+{
+	long tmp;
+	_ATOMIC_LOAD(long, p, memory_order_acquire, true);
+	return (tmp);
+}
 
-	tmp = atomic_load_explicit(q, memory_order_acquire);
+/*
+ * Store
+ */
+
+#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
+#define _ATOMIC_STORE(T, p, v, mo, barrier) \
+	std::atomic_##T *q = \
+	    reinterpret_cast<std::atomic_##T *>(const_cast<T *>(p)); \
+	q->store(std::##mo)
+#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
+#define _ATOMIC_STORE(T, p, v, mo, barrier) \
+	atomic_##T *q = (atomic_##T *)RTEMS_DEVOLATILE(T *, p); \
+	atomic_store_explicit(q, v, mo)
 #else
-	RTEMS_COMPILER_MEMORY_BARRIER();
-	tmp = *p;
+#define _ATOMIC_STORE(T, p, v, mo, barrier) \
+	*p = v; \
+	if (barrier) \
+		RTEMS_COMPILER_MEMORY_BARRIER()
 #endif
 
-	return (tmp);
+static inline void
+atomic_store_int(volatile int *p, int v)
+{
+	_ATOMIC_STORE(int, p, v, memory_order_relaxed, false);
 }
 
 static inline void
-atomic_store_rel_32(volatile uint32_t *p, uint32_t v)
+atomic_store_rel_int(volatile int *p, int v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_uint_least32_t *q =
-	    reinterpret_cast<std::atomic_uint_least32_t *>(const_cast<uint32_t *>(p));
+	_ATOMIC_STORE(int, p, v, memory_order_release, true);
+}
 
-	q->store(v, std::memory_order_release);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_uint_least32_t *q = (atomic_uint_least32_t *)RTEMS_DEVOLATILE(uint32_t *, p);
+static inline void
+atomic_store_rel_32(volatile uint32_t *p, uint32_t v)
+{
+	_ATOMIC_STORE(uint32_t, p, v, memory_order_release, true);
+}
 
-	atomic_store_explicit(q, v, memory_order_release);
-#else
-	*p = v;
-	RTEMS_COMPILER_MEMORY_BARRIER();
-#endif
+static inline void
+atomic_store_rel_long(volatile long *p, long v)
+{
+	_ATOMIC_STORE(long, p, v, memory_order_release, true);
 }
 
-static inline uint64_t
-atomic_fetchadd_64(volatile uint64_t *p, uint64_t v)
+static inline void
+atomic_store_rel_ptr(volatile uintptr_t *p, uintptr_t v)
 {
-	uint64_t tmp;
+	/* XXX IPL32 ok with this? */
+	_ATOMIC_STORE(uintptr_t, p, v, memory_order_release, true);
+}
 
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_uint_least64_t *q =
-	    reinterpret_cast<std::atomic_uint_least64_t *>(const_cast<uint64_t *>(p));
+/*
+ * Add
+ */
 
-	tmp = q->fetch_add(v, std::memory_order_seq_cst);
+#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
+#define _ATOMIC_ADD(T, p, v, mo) \
+	std::atomic_##T *q = \
+	    reinterpret_cast<std::atomic_##T *>(const_cast<T *>(p)); \
+	q->fetch_add(v, std::##mo)
 #elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_uint_least64_t *q = (atomic_uint_least64_t *)RTEMS_DEVOLATILE(uint64_t *, p);
-
-	tmp = atomic_fetch_add_explicit(q, v, memory_order_seq_cst);
+#define _ATOMIC_ADD(T, p, v, mo) \
+	atomic_##T *q = (atomic_##T *)RTEMS_DEVOLATILE(T *, p); \
+	atomic_fetch_add_explicit(q, v, mo)
 #else
-	rtems_interrupt_level level;
-
-	rtems_interrupt_disable(level);
-	tmp = *p;
-	*p += v;
-	rtems_interrupt_enable(level);
+#define _ATOMIC_ADD(T, p, v, mo) \
+	rtems_interrupt_level level; \
+	rtems_interrupt_disable(level); \
+	*p += v; \
+	rtems_interrupt_enable(level)
 #endif
 
-	return (tmp);
+static inline void
+atomic_add_int(volatile int *p, int v)
+{
+	_ATOMIC_ADD(int, p, v, memory_order_seq_cst);
 }
 
 static inline void
-atomic_add_long(volatile long *p, long v)
+atomic_add_acq_int(volatile int *p, int v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
-
-	q->fetch_add(v, std::memory_order_seq_cst);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+	_ATOMIC_ADD(int, p, v, memory_order_acquire);
+}
 
-	atomic_fetch_add_explicit(q, v, memory_order_seq_cst);
-#else
-	rtems_interrupt_level level;
+static inline void
+atomic_add_rel_int(volatile int *p, int v)
+{
+	_ATOMIC_ADD(int, p, v, memory_order_release);
+}
 
-	rtems_interrupt_disable(level);
-	*p += v;
-	rtems_interrupt_enable(level);
-#endif
+static inline void
+atomic_add_32(volatile uint32_t *p, uint32_t v)
+{
+	_ATOMIC_ADD(uint32_t, p, v, memory_order_seq_cst);
 }
 
 static inline void
-atomic_add_acq_long(volatile long *p, long v)
+atomic_add_acq_32(volatile uint32_t *p, uint32_t v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+	_ATOMIC_ADD(uint32_t, p, v, memory_order_acquire);
+}
 
-	q->fetch_add(v, std::memory_order_acquire);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+static inline void
+atomic_add_rel_32(volatile uint32_t *p, uint32_t v)
+{
+	_ATOMIC_ADD(uint32_t, p, v, memory_order_release);
+}
 
-	atomic_fetch_add_explicit(q, v, memory_order_acquire);
-#else
-	rtems_interrupt_level level;
+static inline void
+atomic_add_long(volatile long *p, long v)
+{
+	_ATOMIC_ADD(long, p, v, memory_order_seq_cst);
+}
 
-	rtems_interrupt_disable(level);
-	*p += v;
-	rtems_interrupt_enable(level);
-#endif
+static inline void
+atomic_add_acq_long(volatile long *p, long v)
+{
+	_ATOMIC_ADD(long, p, v, memory_order_acquire);
 }
 
 static inline void
 atomic_add_rel_long(volatile long *p, long v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+	_ATOMIC_ADD(long, p, v, memory_order_release);
+}
 
-	q->fetch_add(v, std::memory_order_release);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+/*
+ * Subtract
+ */
 
-	atomic_fetch_add_explicit(q, v, memory_order_release);
+#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
+#define _ATOMIC_SUB(T, p, v, mo) \
+	std::atomic_##T *q = \
+	    reinterpret_cast<std::atomic_##T *>(const_cast<T *>(p)); \
+	q->fetch_sub(v, std::##mo)
+#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
+#define _ATOMIC_SUB(T, p, v, mo) \
+	atomic_##T *q = (atomic_##T *)RTEMS_DEVOLATILE(T *, p); \
+	atomic_fetch_sub_explicit(q, v, mo)
 #else
-	rtems_interrupt_level level;
-
-	rtems_interrupt_disable(level);
-	*p += v;
-	rtems_interrupt_enable(level);
+#define _ATOMIC_SUB(T, p, v, mo) \
+	rtems_interrupt_level level; \
+	rtems_interrupt_disable(level); \
+	*p -= v; \
+	rtems_interrupt_enable(level)
 #endif
+
+static inline void
+atomic_subtract_int(volatile int *p, int v)
+{
+	_ATOMIC_SUB(int, p, v, memory_order_seq_cst);
 }
 
 static inline void
-atomic_subtract_long(volatile long *p, long v)
+atomic_subtract_acq_int(volatile int *p, int v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+	_ATOMIC_SUB(int, p, v, memory_order_acquire);
+}
 
-	q->fetch_sub(v, std::memory_order_seq_cst);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+static inline void
+atomic_subtract_rel_int(volatile int *p, int v)
+{
+	_ATOMIC_SUB(int, p, v, memory_order_release);
+}
 
-	atomic_fetch_sub_explicit(q, v, memory_order_seq_cst);
-#else
-	rtems_interrupt_level level;
+static inline void
+atomic_subtract_32(volatile uint32_t *p, uint32_t v)
+{
+	_ATOMIC_SUB(uint32_t, p, v, memory_order_seq_cst);
+}
 
-	rtems_interrupt_disable(level);
-	*p -= v;
-	rtems_interrupt_enable(level);
-#endif
+static inline void
+atomic_subtract_acq_32(volatile uint32_t *p, uint32_t v)
+{
+	_ATOMIC_SUB(uint32_t, p, v, memory_order_acquire);
+}
+
+static inline void
+atomic_subtract_rel_32(volatile uint32_t *p, uint32_t v)
+{
+	_ATOMIC_SUB(uint32_t, p, v, memory_order_release);
+}
+
+static inline void
+atomic_subtract_long(volatile long *p, long v)
+{
+	_ATOMIC_SUB(long, p, v, memory_order_seq_cst);
 }
 
 static inline void
 atomic_subtract_acq_long(volatile long *p, long v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+	_ATOMIC_SUB(long, p, v, memory_order_acquire);
+}
 
-	q->fetch_sub(v, std::memory_order_acquire);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+static inline void
+atomic_subtract_rel_long(volatile long *p, long v)
+{
+	_ATOMIC_SUB(long, p, v, memory_order_release);
+}
 
-	atomic_fetch_sub_explicit(q, v, memory_order_acquire);
-#else
-	rtems_interrupt_level level;
+/*
+ * Set
+ */
 
-	rtems_interrupt_disable(level);
-	*p -= v;
-	rtems_interrupt_enable(level);
+#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
+#define _ATOMIC_SET(T, p, v, mo) \
+	std::atomic_##T *q = \
+	    reinterpret_cast<std::atomic_##T *>(const_cast<T *>(p)); \
+	q->fetch_or(v, std::##mo)
+#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
+#define _ATOMIC_SET(T, p, v, mo) \
+	atomic_##T *q = (atomic_##T *)RTEMS_DEVOLATILE(T *, p); \
+	atomic_fetch_or_explicit(q, v, mo)
+#else
+#define _ATOMIC_SET(T, p, v, mo) \
+	rtems_interrupt_level level; \
+	rtems_interrupt_disable(level); \
+	*p |= v; \
+	rtems_interrupt_enable(level)
 #endif
+
+static inline void
+atomic_set_int(volatile int *p, int v)
+{
+	_ATOMIC_SET(int, p, v, memory_order_seq_cst);
 }
 
 static inline void
-atomic_subtract_rel_long(volatile long *p, long v)
+atomic_set_acq_int(volatile int *p, int v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+	_ATOMIC_SET(int, p, v, memory_order_acquire);
+}
 
-	q->fetch_sub(v, std::memory_order_release);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+static inline void
+atomic_set_rel_int(volatile int *p, int v)
+{
+	_ATOMIC_SET(int, p, v, memory_order_release);
+}
 
-	atomic_fetch_sub_explicit(q, v, memory_order_release);
-#else
-	rtems_interrupt_level level;
+static inline void
+atomic_set_32(volatile uint32_t *p, uint32_t v)
+{
+	_ATOMIC_SET(uint32_t, p, v, memory_order_seq_cst);
+}
 
-	rtems_interrupt_disable(level);
-	*p -= v;
-	rtems_interrupt_enable(level);
-#endif
+static inline void
+atomic_set_acq_32(volatile uint32_t *p, uint32_t v)
+{
+	_ATOMIC_SET(uint32_t, p, v, memory_order_acquire);
+}
+
+static inline void
+atomic_set_rel_32(volatile uint32_t *p, uint32_t v)
+{
+	_ATOMIC_SET(uint32_t, p, v, memory_order_release);
 }
 
 static inline void
 atomic_set_long(volatile long *p, long v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+	_ATOMIC_SET(long, p, v, memory_order_seq_cst);
+}
 
-	q->fetch_or(v, std::memory_order_seq_cst);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+static inline void
+atomic_set_acq_long(volatile long *p, long v)
+{
+	_ATOMIC_SET(long, p, v, memory_order_acquire);
+}
 
-	atomic_fetch_or_explicit(q, v, memory_order_seq_cst);
-#else
-	rtems_interrupt_level level;
+static inline void
+atomic_set_rel_long(volatile long *p, long v)
+{
+	_ATOMIC_SET(long, p, v, memory_order_release);
+}
 
-	rtems_interrupt_disable(level);
-	*p |= v;
-	rtems_interrupt_enable(level);
+/*
+ * Clear
+ */
+
+#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
+#define _ATOMIC_CLEAR(T, p, v, mo) \
+	std::atomic_##T *q = \
+	    reinterpret_cast<std::atomic_##T *>(const_cast<T *>(p)); \
+	q->fetch_and(~v, std::##mo)
+#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
+#define _ATOMIC_CLEAR(T, p, v, mo) \
+	atomic_##T *q = (atomic_##T *)RTEMS_DEVOLATILE(T *, p); \
+	atomic_fetch_and_explicit(q, ~v, mo)
+#else
+#define _ATOMIC_CLEAR(T, p, v, mo) \
+	rtems_interrupt_level level; \
+	rtems_interrupt_disable(level); \
+	*p &= ~v; \
+	rtems_interrupt_enable(level)
 #endif
+
+static inline void
+atomic_clear_int(volatile int *p, int v)
+{
+	_ATOMIC_CLEAR(int, p, v, memory_order_seq_cst);
+}
+
+static inline void
+atomic_clear_acq_int(volatile int *p, int v)
+{
+	_ATOMIC_CLEAR(int, p, v, memory_order_acquire);
+}
+
+static inline void
+atomic_clear_rel_int(volatile int *p, int v)
+{
+	_ATOMIC_CLEAR(int, p, v, memory_order_release);
+}
+
+static inline void
+atomic_clear_32(volatile uint32_t *p, uint32_t v)
+{
+	_ATOMIC_CLEAR(uint32_t, p, v, memory_order_seq_cst);
 }
 
 static inline void
-atomic_set_acq_long(volatile long *p, long v)
+atomic_clear_acq_32(volatile uint32_t *p, uint32_t v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
-
-	q->fetch_or(v, std::memory_order_acquire);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
-
-	atomic_fetch_or_explicit(q, v, memory_order_acquire);
-#else
-	rtems_interrupt_level level;
-
-	rtems_interrupt_disable(level);
-	*p |= v;
-	rtems_interrupt_enable(level);
-#endif
+	_ATOMIC_CLEAR(uint32_t, p, v, memory_order_acquire);
 }
 
 static inline void
-atomic_set_rel_long(volatile long *p, long v)
+atomic_clear_rel_32(volatile uint32_t *p, uint32_t v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
-
-	q->fetch_or(v, std::memory_order_release);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
-
-	atomic_fetch_or_explicit(q, v, memory_order_release);
-#else
-	rtems_interrupt_level level;
-
-	rtems_interrupt_disable(level);
-	*p |= v;
-	rtems_interrupt_enable(level);
-#endif
+	_ATOMIC_CLEAR(uint32_t, p, v, memory_order_release);
 }
 
 static inline void
 atomic_clear_long(volatile long *p, long v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
-
-	q->fetch_and(~v, std::memory_order_seq_cst);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
-
-	atomic_fetch_and_explicit(q, ~v, memory_order_seq_cst);
-#else
-	rtems_interrupt_level level;
-
-	rtems_interrupt_disable(level);
-	*p &= ~v;
-	rtems_interrupt_enable(level);
-#endif
+	_ATOMIC_CLEAR(long, p, v, memory_order_release);
 }
 
 static inline void
 atomic_clear_acq_long(volatile long *p, long v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
-
-	q->fetch_and(~v, std::memory_order_acquire);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
-
-	atomic_fetch_and_explicit(q, ~v, memory_order_acquire);
-#else
-	rtems_interrupt_level level;
-
-	rtems_interrupt_disable(level);
-	*p &= ~v;
-	rtems_interrupt_enable(level);
-#endif
+	_ATOMIC_CLEAR(long, p, v, memory_order_acquire);
 }
 
 static inline void
 atomic_clear_rel_long(volatile long *p, long v)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+	_ATOMIC_CLEAR(long, p, v, memory_order_release);
+}
 
-	q->fetch_and(~v, std::memory_order_release);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+/*
+ * Compare and set
+ */
 
-	atomic_fetch_and_explicit(q, ~v, memory_order_release);
+#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
+#define _ATOMIC_CMPSET(T, p, cmp, set, mo) \
+	std::atomic_##T *q = \
+	    reinterpret_cast<std::atomic_##T *>(const_cast<T *>(p)); \
+	rv = q->compare_exchange_strong(cmp, set, \
+            std::##mo, std::memory_order_relaxed)
+#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
+#define _ATOMIC_CMPSET(T, p, cmp, set, mo) \
+	atomic_##T *q = (atomic_##T *)RTEMS_DEVOLATILE(T *, p); \
+	atomic_compare_exchange_strong_explicit(q, &cmp, set, \
+            mo, memory_order_relaxed)
 #else
-	rtems_interrupt_level level;
-
-	rtems_interrupt_disable(level);
-	*p &= ~v;
+#define _ATOMIC_CMPSET(T, p, cmp, set, mo) \
+	rtems_interrupt_level level; \
+	rtems_interrupt_disable(level); \
+	rv = *p == cmp; \
+	if (rv) { \
+		*p = set; \
+	} \
 	rtems_interrupt_enable(level);
 #endif
+
+static inline int
+atomic_cmpset_int(volatile int *p, int cmp, int set)
+{
+	int rv;
+	_ATOMIC_CMPSET(int, p, cmp, set, memory_order_seq_cst);
+	return (rv);
 }
 
 static inline int
-atomic_cmpset_long(volatile long *p, long cmp, long set)
+atomic_cmpset_acq_int(volatile int *p, int cmp, int set)
 {
 	int rv;
+	_ATOMIC_CMPSET(int, p, cmp, set, memory_order_acquire);
+	return (rv);
+}
 
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+static inline int
+atomic_cmpset_rel_int(volatile int *p, int cmp, int set)
+{
+	int rv;
+	_ATOMIC_CMPSET(int, p, cmp, set, memory_order_release);
+	return (rv);
+}
 
-	rv = q->compare_exchange_strong(cmp, set, std::memory_order_seq_cst,
-	    std::memory_order_relaxed);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+static inline int
+atomic_cmpset_32(volatile uint32_t *p, uint32_t cmp, uint32_t set)
+{
+	int rv;
+	_ATOMIC_CMPSET(uint_least32_t, p, cmp, set, memory_order_seq_cst);
+	return (rv);
+}
 
-	rv = atomic_compare_exchange_strong_explicit(q, &cmp, set,
-	    memory_order_seq_cst, memory_order_relaxed);
-#else
-	rtems_interrupt_level level;
+static inline int
+atomic_cmpset_acq_32(volatile uint32_t *p, uint32_t cmp, uint32_t set)
+{
+	int rv;
+	_ATOMIC_CMPSET(uint_least32_t, p, cmp, set, memory_order_acquire);
+	return (rv);
+}
 
-	rtems_interrupt_disable(level);
-	rv = *p == cmp;
-	if (rv) {
-		*p = set;
-	}
-	rtems_interrupt_enable(level);
-#endif
+static inline int
+atomic_cmpset_rel_32(volatile uint32_t *p, uint32_t cmp, uint32_t set)
+{
+	int rv;
+	_ATOMIC_CMPSET(uint_least32_t, p, cmp, set, memory_order_release);
+	return (rv);
+}
 
+static inline int
+atomic_cmpset_64(volatile uint64_t *p, uint64_t cmp, uint64_t set)
+{
+	int rv;
+	_ATOMIC_CMPSET(uint_least64_t, p, cmp, set, memory_order_seq_cst);
 	return (rv);
 }
 
 static inline int
-atomic_cmpset_acq_long(volatile long *p, long cmp, long set)
+atomic_cmpset_acq_64(volatile uint64_t *p, uint64_t cmp, uint64_t set)
 {
 	int rv;
+	_ATOMIC_CMPSET(uint_least64_t, p, cmp, set, memory_order_acquire);
+	return (rv);
+}
 
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+static inline int
+atomic_cmpset_rel_64(volatile uint64_t *p, uint64_t cmp, uint64_t set)
+{
+	int rv;
+	_ATOMIC_CMPSET(uint_least64_t, p, cmp, set, memory_order_release);
+	return (rv);
+}
 
-	rv = q->compare_exchange_strong(cmp, set, std::memory_order_acquire,
-	    std::memory_order_relaxed);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+static inline int
+atomic_cmpset_long(volatile long *p, long cmp, long set)
+{
+	int rv;
+	_ATOMIC_CMPSET(long, p, cmp, set, memory_order_seq_cst);
+	return (rv);
+}
 
-	rv = atomic_compare_exchange_strong_explicit(q, &cmp, set,
-	    memory_order_acquire, memory_order_relaxed);
-#else
-	rtems_interrupt_level level;
+static inline int
+atomic_cmpset_acq_long(volatile long *p, long cmp, long set)
+{
+	int rv;
+	_ATOMIC_CMPSET(long, p, cmp, set, memory_order_acquire);
+	return (rv);
+}
 
-	rtems_interrupt_disable(level);
-	rv = *p == cmp;
-	if (rv) {
-		*p = set;
-	}
-	rtems_interrupt_enable(level);
-#endif
+static inline int
+atomic_cmpset_rel_long(volatile long *p, long cmp, long set)
+{
+	int rv;
+	_ATOMIC_CMPSET(long, p, cmp, set, memory_order_release);
+	return (rv);
+}
 
+static inline int
+atomic_cmpset_ptr(volatile uintptr_t *p, uintptr_t cmp, uintptr_t set)
+{
+	int rv;
+	_ATOMIC_CMPSET(uintptr_t, p, cmp, set, memory_order_seq_cst);
 	return (rv);
 }
 
 static inline int
-atomic_cmpset_rel_long(volatile long *p, long cmp, long set)
+atomic_cmpset_acq_ptr(volatile uintptr_t *p, uintptr_t cmp, uintptr_t set)
 {
 	int rv;
+	_ATOMIC_CMPSET(uintptr_t, p, cmp, set, memory_order_aquire);
+	return (rv);
+}
 
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+static inline int
+atomic_cmpset_rel_ptr(volatile uintptr_t *p, uintptr_t cmp, uintptr_t set)
+{
+	int rv;
+	_ATOMIC_CMPSET(uintptr_t, p, cmp, set, memory_order_release);
+	return (rv);
+}
 
-	rv = q->compare_exchange_strong(cmp, set, std::memory_order_release,
-	    std::memory_order_relaxed);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+/*
+ * Fetch compare and set
+ */
 
-	rv = atomic_compare_exchange_strong_explicit(q, &cmp, set,
-	    memory_order_release, memory_order_relaxed);
+#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
+#define _ATOMIC_FCMPSET(T, p, cmp, set, mo) \
+	std::atomic_##T *q = \
+	    reinterpret_cast<std::atomic_##T *>(const_cast<T *>(p)); \
+	rv = q->compare_exchange_strong(*cmp, set, \
+            std::##mo, std::memory_order_relaxed)
+#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
+#define _ATOMIC_FCMPSET(T, cmp, set, mo) \
+	atomic_##T *q = (atomic_##T *)RTEMS_DEVOLATILE(T *, p); \
+	atomic_compare_exchange_strong_explicit(q, cmp, set, \
+           mo, memory_order_relaxed)
 #else
-	rtems_interrupt_level level;
-
-	rtems_interrupt_disable(level);
-	rv = *p == cmp;
-	if (rv) {
-		*p = set;
-	}
+#define _ATOMIC_FCMPSET(T, p, cmp, set, mo) \
+	rtems_interrupt_level level; \
+        T actual; \
+	rtems_interrupt_disable(level); \
+	actual = *p; \
+	rv = actual == *cmp; \
+	*cmp = actual; \
+	if (rv) { \
+		*p = set; \
+	} \
 	rtems_interrupt_enable(level);
 #endif
 
+static inline int
+atomic_fcmpset_int(volatile int *p, int *cmp, int set)
+{
+	int rv;
+	_ATOMIC_FCMPSET(int, p, cmp, set, memory_order_seq_cst);
 	return (rv);
 }
 
-static inline long
-atomic_fetchadd_long(volatile long *p, long v)
+static inline int
+atomic_fcmpset_acq_int(volatile int *p, int *cmp, int set)
 {
-	long tmp;
+	int rv;
+	_ATOMIC_FCMPSET(int, p, cmp, set, memory_order_acquire);
+	return (rv);
+}
 
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+static inline int
+atomic_fcmpset_rel_int(volatile int *p, int *cmp, int set)
+{
+	int rv;
+	_ATOMIC_FCMPSET(int, p, cmp, set, memory_order_release);
+	return (rv);
+}
 
-	tmp = q->fetch_add(v, std::memory_order_seq_cst);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+static inline int
+atomic_fcmpset_64(volatile uint64_t *p, uint64_t *cmp, uint64_t set)
+{
+	int rv;
+	_ATOMIC_FCMPSET(uint_least64_t, p, cmp, set, memory_order_seq_cst);
+	return (rv);
+}
 
-	tmp = atomic_fetch_add_explicit(q, v, memory_order_seq_cst);
-#else
-	rtems_interrupt_level level;
+static inline int
+atomic_fcmpset_acq_64(volatile uint64_t *p, uint64_t *cmp, uint64_t set)
+{
+	int rv;
+	_ATOMIC_FCMPSET(uint_least64_t, p, cmp, set, memory_order_acquite);
+	return (rv);
+}
 
-	rtems_interrupt_disable(level);
-	tmp = *p;
-	*p += v;
-	rtems_interrupt_enable(level);
-#endif
+static inline int
+atomic_fcmpset_rel_64(volatile uint64_t *p, uint64_t *cmp, uint64_t set)
+{
+	int rv;
+	_ATOMIC_FCMPSET(uint_least64_t, p, cmp, set, memory_order_release);
+	return (rv);
+}
 
-	return (tmp);
+/*  XXX Is IPL32 ok with the .*_ptr versions? */
+static inline int
+atomic_fcmpset_ptr(volatile uintptr_t *p, uintptr_t *cmp, uintptr_t set)
+{
+	int rv;
+	_ATOMIC_FCMPSET(uintptr_t, p, cmp, set, memory_order_seq_cst);
+	return (rv);
 }
 
-static inline long
-atomic_readandclear_long(volatile long *p)
+static inline int
+atomic_fcmpset_acq_ptr(volatile uintptr_t *p, uintptr_t *cmp, uintptr_t set)
 {
-	long tmp;
+	int rv;
+	_ATOMIC_FCMPSET(uintptr_t, p, cmp, set, memory_order_acquire);
+	return (rv);
+}
 
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+static inline int
+atomic_fcmpset_rel_ptr(volatile uintptr_t *p, uintptr_t *cmp, uintptr_t set)
+{
+	int rv;
+	_ATOMIC_FCMPSET(uintptr_t, p, cmp, set, memory_order_release);
+	return (rv);
+}
 
-	tmp = q->exchange(0, std::memory_order_seq_cst);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+/*
+ * Fetch add
+ */
 
-	tmp = atomic_exchange_explicit(q, 0, memory_order_seq_cst);
+#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
+#define _ATOMIC_FETCHADD(T, p, v, mo) \
+	std::atomic_##T *q = \
+	    reinterpret_cast<std::atomic_##T *>(const_cast<T *>(p)); \
+	tmp = q->fetch_add(v, std::##mo)
+#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
+#define _ATOMIC_FETCHADD(T, p, v, mo) \
+	atomic_##T *q = (atomic_##T *)RTEMS_DEVOLATILE(T *, p); \
+	tmp = atomic_fetch_add_explicit(q, v, mo)
 #else
-	rtems_interrupt_level level;
-
-	rtems_interrupt_disable(level);
-	tmp = *p;
-	*p = 0;
+#define _ATOMIC_FETCHADD(T, p, v, mo) \
+	rtems_interrupt_level level; \
+	rtems_interrupt_disable(level); \
+	tmp = *p; \
+	*p += v; \
 	rtems_interrupt_enable(level);
 #endif
 
+static inline int
+atomic_fetchadd_int(volatile int *p, int v)
+{
+	int tmp;
+	_ATOMIC_FETCHADD(int, p, v, memory_order_order_seq_cst);
 	return (tmp);
 }
 
-static inline long
-atomic_load_long(volatile long *p)
+static inline uint32_t
+atomic_fetchadd_32(volatile uint32_t *p, uint32_t v)
 {
-	long tmp;
-
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
-
-	tmp = q->load(std::memory_order_relaxed);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
-
-	tmp = atomic_load_explicit(q, memory_order_relaxed);
-#else
-	tmp = *p;
-#endif
+	uint32_t tmp;
+	_ATOMIC_FETCHADD(uint32_t, p, v, memory_order_order_seq_cst);
+	return (tmp);
+}
 
+static inline uint64_t
+atomic_fetchadd_64(volatile uint64_t *p, uint64_t v)
+{
+	uint64_t tmp;
+	_ATOMIC_FETCHADD(uint64_t, p, v, memory_order_order_seq_cst);
 	return (tmp);
 }
 
 static inline long
-atomic_load_acq_long(volatile long *p)
+atomic_fetchadd_long(volatile long *p, long v)
 {
 	long tmp;
+	_ATOMIC_FETCHADD(long, p, v, memory_order_order_seq_cst);
+	return (tmp);
+}
 
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
+/*
+ * Read and clear
+ */
 
-	tmp = q->load(std::memory_order_acquire);
+#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
+#define _ATOMIC_READANDCLEAR(T, p, mo) \
+	std::atomic_##T *q = \
+	    reinterpret_cast<std::atomic_##T *>(const_cast<T *>(p)); \
+	tmp = q->exchange(0, std::##mo)
 #elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
-
-	tmp = atomic_load_explicit(q, memory_order_acquire);
+#define _ATOMIC_READANDCLEAR(T, p, mo) \
+	atomic_##T *q = (atomic_##T *)RTEMS_DEVOLATILE(T *, p); \
+	tmp = atomic_exchange_explicit(q, 0, mo)
 #else
-	RTEMS_COMPILER_MEMORY_BARRIER();
-	tmp = *p;
+#define _ATOMIC_READANDCLEAR(T, p, mo) \
+	rtems_interrupt_level level; \
+	rtems_interrupt_disable(level); \
+	tmp = *p; \
+	*p = 0; \
+	rtems_interrupt_enable(level);
 #endif
 
+static inline int
+atomic_readandclear_int(volatile int *p)
+{
+	int tmp;
+	_ATOMIC_READANDCLEAR(int, p, memory_order_order_seq_cst);
 	return (tmp);
 }
 
-static inline void
-atomic_store_rel_long(volatile long *p, long v)
+static inline uint32_t
+atomic_readandclear_32(volatile uint32_t *p)
 {
-#if defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_ATOMIC)
-	std::atomic_long *q =
-	    reinterpret_cast<std::atomic_long *>(const_cast<long *>(p));
-
-	q->store(v, std::memory_order_release);
-#elif defined(_RTEMS_BSD_MACHINE_ATOMIC_USE_STDATOMIC)
-	atomic_long *q = (atomic_long *)RTEMS_DEVOLATILE(long *, p);
+	uint32_t tmp;
+	_ATOMIC_READANDCLEAR(uint_least32_t, p, memory_order_order_seq_cst);
+	return (tmp);
+}
 
-	atomic_store_explicit(q, v, memory_order_release);
-#else
-	*p = v;
-	RTEMS_COMPILER_MEMORY_BARRIER();
-#endif
+static inline long
+atomic_readandclear_long(volatile long *p)
+{
+	long tmp;
+	_ATOMIC_READANDCLEAR(long, p, memory_order_order_seq_cst);
+	return (tmp);
 }
 
+/*
+ * Thread fence
+ */
+
 static inline void
 atomic_thread_fence_acq(void)
 {
diff --git a/rtemsbsd/include/machine/rtems-bsd-config.h b/rtemsbsd/include/machine/rtems-bsd-config.h
index 491d9a72..a820e51d 100644
--- a/rtemsbsd/include/machine/rtems-bsd-config.h
+++ b/rtemsbsd/include/machine/rtems-bsd-config.h
@@ -85,6 +85,12 @@ extern "C" {
   #define RTEMS_BSD_CFGDECL_DOMAIN_PAGE_MBUFS_SIZE RTEMS_BSD_ALLOCATOR_DOMAIN_PAGE_MBUF_DEFAULT
 #endif
 
+#if defined(RTEMS_BSD_CONFIG_DOMAIN_BIO_SIZE)
+  #define RTEMS_BSD_CFGDECL_DOMAIN_BIO_SIZE RTEMS_BSD_CONFIG_DOMAIN_BIO_SIZE
+#else
+  #define RTEMS_BSD_CFGDECL_DOMAIN_BIO_SIZE RTEMS_BSD_ALLOCATOR_DOMAIN_BIO_DEFAULT
+#endif
+
 /*
  * BSD Kernel modules.
  */
@@ -222,6 +228,12 @@ extern "C" {
   uintptr_t rtems_bsd_allocator_domain_page_mbuf_size = \
     RTEMS_BSD_CFGDECL_DOMAIN_PAGE_MBUFS_SIZE;
 
+  /*
+   * Configure the block IO buffer memory size.
+   */
+  uintptr_t rtems_bsd_allocator_domain_bio_size = \
+    RTEMS_BSD_CFGDECL_DOMAIN_BIO_SIZE;
+
   /*
    * If a BSP configuration is requested include the Nexus bus BSP
    * configuration.
